#!/usr/bin/python3
# -*- coding: utf-8 -*-

import os
import sys
import uuid
import dbus
import Ifcfg
import socket
import platform
import subprocess
import apt
import fcntl
from fcntl import ioctl  
import socket
import struct
import time 
# BASE_DIR=os.path.dirname(os.path.dirname(os.path.abspath(__file__))) # __file__获取执行文件相对路径，整行为取上一级的上一级目录
# sys.path.append(BASE_DIR) # 添加临时的路径
# import kylin_sendjson


LSB_RELEASE_PATH="/etc/lsb-release"
NET_PATH="/sys/class/net/"
MACHINEID_PATH="/etc/machine-id"


class UpdateInfo():
    def __init__ (self):
        self.MacInfo = {}
        self.udi = {}
        self.isi = {}
        self.update_infos = {
            'machine-id':"",
            'ip':"",
            'os-version':"",
            'kum-version':"",
            'mac':"",
            'date':"",
            'pkg-name':"",
            'source':"unKnown",
            'status':'fail',
            'uuid':"",
            'sent':'true'}
        self.install_info = {
            'uuid':"0",
            'pkg-name':"",
            'init-version':"",
            'inst-version':"",
            'status':"",
            'errormsg':""
        }
        self.udi["update-infos"] = self.update_infos
        self.isi["install-info"] = self.install_info
        # print("\nkylin_sendjson.confinit\n")
        # kylin_sendjson.confinit()


class GetUpdateInfos():
    def __init__ (self):
        self.hostname = ""
        self.ip = ""
        self.os_version = ""
        self.deb_version = ""
        self.macinfo = {}
        self.date = ""
        self.machineid = ""
        self.uuid = ""

    def GetHostIp(self):
        try:
            self.hostname = socket.gethostname()
            self.ip = socket.gethostbyname(self.hostname)
            # print("self.hostname: ", self.hostname)
            print("self.ip: ", self.ip,type(self.ip))
        except Exception:
            print("GetHostIp error")
        return self.ip
    
    def GetHostIp1(self):
        try:
            self.Mac = self.GetMacAddress1()
            # print("self.Mac: ", self.Mac)
            for name, interface in Ifcfg.interfaces().items():
                pass
            default = Ifcfg.default_interface()
            # print("default ", default)
            self.ip =  default['inet']
            print("self.ip ", self.ip)
        except Exception:
            print("GetHostIp1 error")
        return self.ip

    def GetMachineId(self):
        try:
            fd = open(MACHINEID_PATH, "r+")
            self.machineid = fd.read().strip()
        except Exception:
            print("GetMachineId error")
        return self.machineid

    def GenerateUUID(self):
        try:
            self.uuid = str(uuid.uuid1())
            # print("self.uuid: ", self.uuid)
        except Exception as e:
            print("GenerateUUID error: ", str(e))
        return self.uuid

    def GetOsVersion(self):
        try:
            fd = open(LSB_RELEASE_PATH, "r+")
            while 1:
                line = fd.readline()
                if not line:
                    break
                elif 'DISTRIB_DESCRIPTION' in line:
                    self.os_version = line.split('=',2)[1]
                    self.os_version = self.os_version.strip().strip('\"').replace(" ", "")
                    # if "kylin" in self.os_version:
                    #     self.os_version = self.os_version.replace("kylin", '')
                    # elif "Kylin" in self.os_version:
                    #     self.os_version = self.os_version.replace("Kylin", '')
        except Exception as e:
            print("GetOsVersion error: ", str(e))
        return self.os_version
    
    # 获得已安装的包版本
    def GetAppVersion(self, pkgname):
        try:
            cache = apt.Cache()
            pkg = cache[pkgname]
            dvinstall = pkg.installed
            dv = str(dvinstall)
            self.deb_version = dv.split('=',2)[1]
        except Exception as e:
            print("GetAppVersion error: ", str(e))
        return self.deb_version
    
    def GetMacAddress(self):
        ipaddr = ""
        # mac = uuid.UUID(int=uuid.getnode()).hex[-12:]
        # host_mac = ":".join([mac[e:e + 2] for e in range(0, 11, 2)])
        # print("host_mac: ", host_mac)
        try:
            for netdev in os.listdir(NET_PATH):
                file_path = os.path.join(NET_PATH, netdev)
                addr_path = ''.join([file_path, "/address"])
                fd = open(addr_path, "r")
                macaddr = fd.read().strip()
                if '00:00:00:00' not in macaddr:
                    self.macinfo[netdev] = macaddr
            # print(self.macinfo)
            dictkeys = self.macinfo.keys()
            hostip = socket.gethostbyname(socket.gethostname())
        except Exception as e:
            print("GetMacAddress error: ", str(e))
        
        for netdev in dictkeys:
            # print(netdev)
            sock=socket.socket(socket.AF_INET,socket.SOCK_DGRAM)
            sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR,1)
            try:
                ipaddr = socket.inet_ntoa(fcntl.ioctl(
                            sock.fileno(), 
                            0x8915,  # SIOCGIFADDR 
                            struct.pack(b'256s', netdev.encode('utf-8')) 
                            )[20:24]
                            )
                # print("netdev", netdev)
            except Exception as link_fault:
                pass
            if str(ipaddr) == str(hostip):
                macaddr = self.macinfo[netdev]

        sock.close()
        return macaddr
    
    def GetMacAddress1(self):
        try:
            bus = dbus.SystemBus()
            network_proxy = bus.get_object('org.freedesktop.NetworkManager', '/org/freedesktop/NetworkManager/Devices/2')
            network_interface = dbus.Interface(network_proxy,dbus_interface='org.freedesktop.DBus.Properties')
            mac_address = network_interface.Get('org.freedesktop.NetworkManager.Device.Wired','HwAddress')
            return str(mac_address)
        except:
            return None

    def GetDate(self):
        try:
            # 日期时间
            self.date = time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())
            # 日期
            # self.date = time.strftime("%Y-%m-%d", time.localtime())
            # print("self.date: ", self.date)
        except Exception as e:
            print("GetDate error: ", str(e))
        return self.date

