#!/usr/bin/python3
# -*- coding: utf-8 -*-

import os
import cinfo
import apt
import configparser
import json
import hashlib
import base64
import rsa
from binascii import a2b_hex
import Crypto
from Crypto.PublicKey import RSA
from Crypto.Cipher import PKCS1_OAEP

# INFO_JSON_PATH="/usr/share/kylin-update-manager/kylingetinfo/infoconfig.json"
PUBLICKEY_PATH="/usr/share/kylin-update-manager/kylingetinfo/public.pem"
UPDATEINFO_PATH="/usr/share/kylin-update-manager/kylingetinfo/updatejson"
UPDATE_SNEDFAIL_PATH="/usr/share/kylin-update-manager/kylingetinfo/updatejson/kylin-updateinfo-sendfail.conf"
INSTALL_SNEDFAIL_PATH="/usr/share/kylin-update-manager/kylingetinfo/updatejson/kylin-installinfo-sendfail.conf"


#公钥
uniqueKey = "LS0tLS1CRUdJTiBQVUJMSUMgS0VZLS0tLS0KTUlJQklqQU5CZ2txaGtpRzl3MEJBUUVGQUFPQ0FR\
OEFNSUlCQ2dLQ0FRRUFzdW1NTFJEdlFNb0tEQkRJODRqSgpqc1A0Mk55V0pWVEZob2Jra3ZiT05j\
dExYTXVzRmo2TzJUblZYU3Z6VlVLSjRqZkpwT2l2WEphOVB5Z2wzYTRnClBzSU40enNCMEdOY0tr\
R3VsS2RrV2x6S3lWQ2xlTzhiQnN6SjkwbTc3cWF6YWg3a1A0TUl0WTVFczBpSkpiR0oKN1MxcERj\
MlJkNnVFQWJLaXJyRTFlNzlFTEd4am5VN2V5NWkyRDE2WWJoZEQwZ2lNa2RHR3piQXBKTWZWRVJR\
TQo1NXorMFVqdS8zSFJhNFY3b3p2TGRPRE5HUURaeWNJU0l3VHBLbFR3RjBxazdCNjVhTUlJenQ1\
dnhOK1lxYU1GClppZFRLNzcxNjdqNEExZ3F3MG45bjlybWVXUGRWZ3dudnRtVXp4Q1krNk05SXpK\
TDI3eWpRUTV1WGQ3RVdMT3IKbndJREFRQUIKLS0tLS1FTkQgUFVCTElDIEtFWS0tLS0tCg=="

class Convert():
    def __init__ (self):
        # print("Convert __ init__.")
        pass

    def ConvertJson(self, UpdateInfos):
        try:
            Jsonfile = json.dumps(UpdateInfos)
        except Exception as e:
            print("ConvertJson error: ", str(e))
        return Jsonfile

    def WriteToJson(self, dictInfos):
        # try:
        #     with open(INFO_JSON_PATH, "w+") as f:
        #         json.dump(UpdateInfos, f)
        #         print("wirte to jsonfile:  [",INFO_JSON_PATH,"]  success!")
        # except Exception as e:
        #     print("WriteToJson error: ", str(e))

        try:
            if "update-infos" in dictInfos.keys():
                json_path = UPDATEINFO_PATH + "/" + dictInfos["update-infos"]['pkg-name'] + "_update" +".json"
                json_name = dictInfos["update-infos"]['pkg-name'] + "_update" + ".json"
                print("json_name: ", json_name)
                with open(json_path, "w+") as f:       # 生成json文档
                    json.dump(dictInfos, f)
                # 加入conf文件列表中
                sendfail_pkglist = configparser.ConfigParser(allow_no_value=True)
                sendfail_pkglist.read(UPDATE_SNEDFAIL_PATH)
                pkglist = sendfail_pkglist.get("SENDFAIL", "jsonfile")
                if str(json_name) not in pkglist:
                    sendfail_pkglist.set("SENDFAIL","jsonfile", str(pkglist)+" "+json_name)
                    pkglist = sendfail_pkglist.get("SENDFAIL", "jsonfile")
                with open(UPDATE_SNEDFAIL_PATH,"w+") as f:
                    sendfail_pkglist.write(f)
            elif "install-info" in dictInfos.keys():
                json_path = UPDATEINFO_PATH + "/" + dictInfos["install-info"]['pkg-name'] + "_install" +".json"
                json_name = dictInfos["install-info"]['pkg-name'] + "_install" + ".json"
                # print("json_name: ", json_name)
                with open(json_path, "w+") as f:       # 生成json文档
                    json.dump(dictInfos, f)
                # 加入conf文件列表中
                sendfail_pkglist = configparser.ConfigParser(allow_no_value=True)
                sendfail_pkglist.read(INSTALL_SNEDFAIL_PATH)
                pkglist = sendfail_pkglist.get("SENDFAIL", "jsonfile")
                if str(json_name) not in pkglist:
                    sendfail_pkglist.set("SENDFAIL","jsonfile", str(pkglist)+" "+json_name)
                    pkglist = sendfail_pkglist.get("SENDFAIL", "jsonfile")
                with open(INSTALL_SNEDFAIL_PATH,"w+") as f:
                    sendfail_pkglist.write(f)
            else:
                print("dict err.")
        except Exception as e:
            print("WriteToJson error: ", str(e))

        return True

    # 加载本地pem公钥加密
    def enMd5Base64(self, UpdateInfos): # dict
        try:  
            # 生成MD5 
            strUdInfos = json.dumps(UpdateInfos).replace(" ", "")          # json str
            md5info = hashlib.md5(strUdInfos.encode('utf-8')).hexdigest()  # md5(str)

            md5hex = a2b_hex(md5info)           # md5(str) -> b'md5'

            # 对base64编码的md5 RSA公钥加密
            with open(PUBLICKEY_PATH, 'rb') as publickfile:
                p = publickfile.read()                           # bytes pubkey 
            rsa_pubkey = RSA.importKey(p)
            oaep_pub = PKCS1_OAEP.new(rsa_pubkey)                # OAEP 填充

            enMB = oaep_pub.encrypt(md5hex)
            # print("enMB: ", enMB)
            ciphervalue_enc = base64.b64encode(enMB)   
            # print("demo 密文: ", ciphervalue_enc)
        except Exception as e:
            print("enMd5Base64 error: ", str(e))
        return ciphervalue_enc  # 返回密文encrypt

    # Crypto base64 uniqueKey加密
    def uniqueEnMd5Base64(self, UpdateInfos):
        try:
            strUdInfos = json.dumps(UpdateInfos).replace(" ", "")
            md5info = hashlib.md5(strUdInfos.encode('utf-8')).hexdigest() # json -> Md5
            md5hex = a2b_hex(md5info)   # hex md5  
        # 1    
            # load uniqueKey
            # print("publicKey: ", publicKey)
            # bytepub = publicKey.encode('utf-8')
            # print("bytepub: ", bytepub)
            # rsa_pubkey = RSA.importKey(bytepub)
            # oaep_pub = PKCS1_OAEP.new(rsa_pubkey)
            # # # encrypt #base64# 
            # enMB = oaep_pub.encrypt(md5hex)
            # ciphervalue_enc = base64.b64encode(enMB)   
            # print("demo 密文: ", ciphervalue_enc)
            # basepub = base64.b64encode(bytepub)  
            # print("basepub: ", basepub)

        # 2
            # print("uniqueKey: ", uniqueKey)
            uniqueKeybase = uniqueKey.encode('utf-8')
            # print("uniqueKeybase: ", uniqueKeybase) 
            uniqueKeyorig = base64.b64decode(uniqueKeybase)
            rsa_pubkey = RSA.importKey(uniqueKeyorig)
            oaep_pub = PKCS1_OAEP.new(rsa_pubkey)
            
            # encrypt 转base64
            enMB = oaep_pub.encrypt(md5hex)
            enMD5Base = base64.b64encode(enMB)   
            # print("enMD5Base: ", enMD5Base)
        except Exception as e:
            print("uniqueEnMd5Base64 error: ", str(e))
        
        return enMD5Base

    # 初始化conf
    def confinit(self):
        updatelist = []
        installlist = []
        # 获取kylin-updateinfo-sendfail.conf中RUN
        updateconf = configparser.ConfigParser(allow_no_value=True)
        updateconf.read(UPDATE_SNEDFAIL_PATH)
        ufinrstRun = updateconf.get("RUN", "initial")
        # 获取kylin-installinfo-sendfail.conf中RUN
        installconf = configparser.ConfigParser(allow_no_value=True)
        installconf.read(INSTALL_SNEDFAIL_PATH)
        ifinrstRun = installconf.get("RUN", "initial")

        for root, dirs, files in os.walk(UPDATEINFO_PATH):  
            # print("files: ", files) #当前路径下所有非目录子文件 
            pass
        try:
            if ufinrstRun == "True":
                print("init uconf!")
                for jsonfile in files:
                    if "_update.json" in jsonfile:
                        updatelist.append(jsonfile)
                # print("updatelist: ", updatelist)
                updateconf.set("SENDFAIL", "jsonfile", " ".join(updatelist))
                updateconf.get("SENDFAIL", "jsonfile")
                updateconf.set("RUN", "initial", "False")
                with open(UPDATE_SNEDFAIL_PATH, "w+") as f:
                    updateconf.write(f)
            if ifinrstRun == "True":
                print("init iconf!")
                for jsonfile in files:
                    if "_install.json" in jsonfile:
                        installlist.append(jsonfile)
                # print("installlist: ", installlist)
                installconf.set("SENDFAIL", "jsonfile", " ".join(installlist))
                installconf.get("SENDFAIL", "jsonfile")
                installconf.set("RUN", "initial", "False")
                with open(INSTALL_SNEDFAIL_PATH, "w+") as f:
                    installconf.write(f)
            else:
                print("not first!")
        except Exception as e:
            print("confinit err.")

