#!/usr/bin/python3
# -*- coding: utf-8 -*-

import os
import sys
import rsa
import dbus
import cinfo 
from cinfo import UpdateInfo
import formatconv
BASE_DIR=os.path.dirname(os.path.dirname(os.path.abspath(__file__))) # __file__获取执行文件相对路径，整行为取上一级的上一级目录
sys.path.append(BASE_DIR) # 添加临时的路径
# print("__file__", __file__)
# print("BASE_DIR", BASE_DIR)
from kylindbus.apt_handler import AppActions, AptHandler, WorkitemError
from kylindbus.log_manager import logger

# udi = UpdateInfo()

class collect():
    def getinfo(self, udi):
        # run(debname, status)
        run(udi)

def run(udi):
    # 初始化对象
    cg = cinfo.GetUpdateInfos()
    cv = formatconv.Convert()

    # 获得IP、MachineId、uuid
    udi.update_infos['machine-id'] = cg.GetMachineId()
    udi.update_infos['ip'] = cg.GetHostIp1()
    udi.update_infos['uuid'] = cg.GenerateUUID()

    # 获取当前日期时间
    udi.update_infos['date'] = cg.GetDate()

    # 获得系统发行版本
    udi.update_infos['os-version'] = cg.GetOsVersion()

    # 获取kylin-update-manager版本
    pkgname = "kylin-update-manager"
    udi.update_infos['kum-version'] = cg.GetAppVersion(pkgname)

    # 当前更新deb包名状态
    udi.update_infos['pkg-name'] = str(udi.install_info['pkg-name'])
    udi.update_infos['status'] = str(udi.install_info['status'])

    # 获取Mac地址
    udi.update_infos['mac'] = cg.GetMacAddress1()

    # print("udi: ", udi.udi)
    # print("isi: ", udi.isi)
    
    # M2Crypto
    # enMB2 = cv.uniqueEnMd5Base64(udi.udi)
    # # dbus demo
    # applicationName="kylin-update-manager"
    # messageType="update-infos"
    # logger.info("demo开始发送-----  ----- ")
    # jsonfile = cv.ConvertJson(udi.udi).replace(" ", "")
    # ret = sendToDbus(applicationName, messageType, jsonfile, enMB2)
    # print("applicationName: ", applicationName, type(applicationName))
    # print("messageType: ", messageType, type(messageType))
    # print("jsonfile   : ", jsonfile, type(jsonfile))
    # print("enMB2: ", enMB2, type(enMB2))
    # logger.info("demo结束发送----- %s ----- ", ret)

    # RSA加密
    enMB = cv.uniqueEnMd5Base64(udi.udi)

    # dbus发送第一组信息:update_infos
    applicationName="kylin-update-manager"
    messageType="update-infos"
    logger.info("UpdateInfos开始发送----- %s ----- ", udi.update_infos['pkg-name'])
    jsonfile = cv.ConvertJson(udi.udi).replace(" ","")
    # 调用dbus发送
    # print("applicationName: ", applicationName)
    # print("messageType: ", messageType)
    # print("jsonfile   : ", jsonfile)
    # print("enMB: ", enMB)
    ret = sendToDbus(applicationName, messageType, jsonfile, enMB)
    if ret != 0: 
        udi.update_infos['sent'] = "false"
        if ret == -102:
            result = "md5解密异常"
            logger.info("发送状态:%s - 包名: %s : result: %s.", udi.update_infos['sent'], udi.update_infos['pkg-name'], result)
        elif ret == -101:
            result = "md5异常"
            logger.info("发送状态:%s - 包名: %s : result: %s.", udi.update_infos['sent'], udi.update_infos['pkg-name'], result)
        elif ret == -5:
            result = "服务器响应异常"
            logger.info("发送状态:%s - 包名: %s : result: %s.", udi.update_infos['sent'], udi.update_infos['pkg-name'], result)
        elif ret == -4:
            result = "md5加密异常"
            logger.info("发送状态:%s - 包名: %s : result: %s.", udi.update_infos['sent'], udi.update_infos['pkg-name'], result)
        elif ret == -3:
            result = "服务器异常"
            logger.info("发送状态:%s - 包名: %s : result: %s.", udi.update_infos['sent'], udi.update_infos['pkg-name'], result)
        elif ret == -2:
            result = "网络异常"
            logger.info("发送状态:%s - 包名: %s : result: %s.", udi.update_infos['sent'], udi.update_infos['pkg-name'], result)
        elif ret == -1:
            result = "information参数无法转化为json格式"
            logger.info("发送状态:%s - 包名: %s : result: %s.", udi.update_infos['sent'], udi.update_infos['pkg-name'], result)
    elif ret == 0:
        udi.update_infos['sent'] = "true"
        result = "发送信息成功"
        logger.info("发送状态:%s - 包名: %s : result: %s.", udi.update_infos['sent'], udi.update_infos['pkg-name'], result)
    logger.info("UpdateInfos结束发送----- %s ----- ", udi.update_infos['pkg-name'])
    # 上传失败写入本地json
    if udi.update_infos['sent'] == "false":
        cv.WriteToJson(udi.udi)

    # RSA加密
    enMB = cv.uniqueEnMd5Base64(udi.isi)

    # dbus发送第二组信息:install_info
    applicationName="kylin-update-manager"
    messageType="install-info"
    logger.info("InstallInfo开始发送----- %s ----- ", udi.install_info['pkg-name'])
    jsonfile = cv.ConvertJson(udi.isi).replace(" ","")
    # 调用dbus发送
    # print("applicationName: ", applicationName)
    # print("messageType: ", messageType)
    # print("jsonfile   : ", jsonfile)
    # print("enMB: ", enMB)
    ret = sendToDbus(applicationName, messageType, jsonfile, enMB)
    if ret != 0: 
        if ret == -102:
            result = "md5解密异常"
            logger.info("发送状态:false - 包名: %s : result: %s.", udi.install_info['pkg-name'], result)
        elif ret == -101:
            result = "md5异常"
            logger.info("发送状态:false - 包名: %s : result: %s.", udi.install_info['pkg-name'], result)
        elif ret == -5:
            result = "服务器响应异常"
            logger.info("发送状态:false - 包名: %s : result: %s.", udi.install_info['pkg-name'], result)
        elif ret == -4:
            result = "md5加密异常"
            logger.info("发送状态:false - 包名: %s : result: %s.", udi.install_info['pkg-name'], result)
        elif ret == -3:
            result = "服务器异常"
            logger.info("发送状态:false - 包名: %s : result: %s.", udi.install_info['pkg-name'], result)
        elif ret == -2:
            result = "网络异常"
            logger.info("发送状态:false - 包名: %s : result: %s.", udi.install_info['pkg-name'], result)
        elif ret == -1:
            result = "information参数无法转化为json格式"
            logger.info("发送状态:false - 包名: %s : result: %s.", udi.install_info['pkg-name'], result)
        # 上传失败写入本地json
        cv.WriteToJson(udi.isi)
    elif ret == 0:
        result = "发送信息成功"
        logger.info("发送状态:true - 包名: %s : result: %s.", udi.install_info['pkg-name'], result)
    logger.info("InstallInfo结束发送----- %s ----- ", udi.install_info['pkg-name'])

def sendToDbus(applicationName, messageType, jsonfile, enMB):
    daqbus = dbus.SystemBus()
    daqobj = daqbus.get_object('com.kylin.daq', '/com/kylin/daq')
    daqinterface = dbus.Interface(daqobj, dbus_interface='com.kylin.daq.interface')
    retval = daqinterface.sendInfo(applicationName, messageType, jsonfile, enMB)
    # if "kylin-video" in str(jsonfile):
    #     return 0
    # print("ret = ", retval)
    return retval

if __name__ == "__main__":
    run()
