#!/usr/bin/python3
# -*- coding: utf-8 -*-

import os
import sys
import dbus
import json
import configparser
BASE_DIR=os.path.dirname(os.path.dirname(os.path.abspath(__file__))) # __file__获取执行文件相对路径，整行为取上一级的上一级目录
sys.path.append(BASE_DIR) # 添加临时的路径
# print("__file__", __file__)
# print("BASE_DIR", BASE_DIR)
from kylingetinfo.formatconv import Convert
from kylindbus.log_manager import logger


# TESTFILE_PATH="/home/kylin/luoxueyi/date.txt"
UPDATEINFO_PATH="/usr/share/kylin-update-manager/kylingetinfo/updatejson"
UPDATE_SNEDFAIL_PATH="/usr/share/kylin-update-manager/kylingetinfo/updatejson/kylin-updateinfo-sendfail.conf"
INSTALL_SNEDFAIL_PATH="/usr/share/kylin-update-manager/kylingetinfo/updatejson/kylin-installinfo-sendfail.conf"

cv = Convert()

def SendJson():
    updatelist = []
    new_updatelist = []
    installlist = []
    new_installlist = []
    cv.confinit()
    # os._exit(0)
    # 获取kylin-updateinfo-sendfail.conf中所有json文件
    sendfail_update = configparser.ConfigParser(allow_no_value=True)
    sendfail_update.read(UPDATE_SNEDFAIL_PATH)
    updatelist = sendfail_update.get("SENDFAIL", "jsonfile")
    updatelist = updatelist.split(" ")

    # 获取kylin-installinfo-sendfail.conf中所有json文件
    sendfail_install = configparser.ConfigParser(allow_no_value=True)
    sendfail_install.read(INSTALL_SNEDFAIL_PATH)
    installlist = sendfail_install.get("SENDFAIL", "jsonfile")
    installlist = installlist.split(" ")

    if len(updatelist) == 1 and updatelist[0] == '' and len(installlist) == 1 and installlist[0] == '':
        logger.info("定时发送: 无将要发送的Json文件.")
        print("无将要发送的Json文件.")
        os._exit(0)

    # 循环发送updateinfo
    for i in updatelist:
        jsonpath = os.path.join(UPDATEINFO_PATH, i)
        print(i)
        try: 
            with open(jsonpath, "r+") as f:
                localfile = f.read()
                # str to json
                jsonfile = json.loads(localfile)
                # Send
                logger.info("UpdateInfos定时发送----- %s ----- ", i)
                print("UpdateInfos定时发送----- %s ----- ", i)
                ret = SendtoServer(jsonfile)
                # sent状态true，发送成功
                if ret != 0: 
                    # print("jsonfile: ", jsonfile)
                    jsonfile['update-infos']['sent'] = "false"
                    if ret == -102:
                        result = "md5解密异常"
                        logger.info("发送状态:%s - 文件名: %s : result: %s.", jsonfile['update-infos']['sent'], i, result)
                    elif ret == -101:
                        result = "md5异常"
                        logger.info("发送状态:%s - 文件名: %s : result: %s.", jsonfile['update-infos']['sent'], i, result)
                    elif ret == -5:
                        result = "服务器响应异常"
                        logger.info("发送状态:%s - 文件名: %s : result: %s.", jsonfile['update-infos']['sent'], i, result)
                    elif ret == -4:
                        result = "md5加密异常"
                        logger.info("发送状态:%s - 文件名: %s : result: %s.", jsonfile['update-infos']['sent'], i, result)
                    elif ret == -3:
                        result = "服务器异常"
                        logger.info("发送状态:%s - 文件名: %s : result: %s.", jsonfile['update-infos']['sent'], i, result)
                    elif ret == -2:
                        result = "网络异常"
                        logger.info("发送状态:%s - 文件名: %s : result: %s.", jsonfile['update-infos']['sent'], i, result)
                    elif ret == -1:
                        result = "information参数无法转化为json格式"
                        logger.info("发送状态:%s - 文件名: %s : result: %s.", jsonfile['update-infos']['sent'], i, result)
                    print("发送状态:%s - 文件名: %s : result: %s.", jsonfile['update-infos']['sent'], i, result)
                    new_updatelist.append(i)             # 发送失败，加入新列表中   
                elif ret == 0:
                    jsonfile['update-infos']['sent'] = "true"
                    print("remove jsonfile: ", jsonpath)
                    os.remove(jsonpath)                # 删除本地json
                    logger.info("删除本地Json----- %s -----", i)
                    result = "发送信息成功"
                    logger.info("发送状态:%s - 文件名: %s : result: %s.", jsonfile['update-infos']['sent'], i, result)
                logger.info("UpdateInfos结束发送----- %s ----- ", jsonfile['update-infos']['pkg-name'])
                print("UpdateInfos结束发送----- %s ----- ", jsonfile['update-infos']['pkg-name'])
            f.close()
        except Exception as e:
            print(".open or remove: ", str(e))
    sendfail_update.set("SENDFAIL","jsonfile", " ".join(new_updatelist))
    with open(UPDATE_SNEDFAIL_PATH,"w+") as f:
        sendfail_update.write(f)

    # 循环发送installinfo
    for i in installlist:
        jsonpath = os.path.join(UPDATEINFO_PATH, i)
        print(i)
        try: 
            with open(jsonpath, "r+") as f:
                localfile = f.read()
                # str to json
                jsonfile = json.loads(localfile)
                # Send
                logger.info("InstallInfos定时发送----- %s ----- ", i)
                print("InstallInfos定时发送----- %s ----- ", i)
                ret = SendtoServer(jsonfile)
                if ret != 0: 
                    if ret == -102:
                        result = "md5解密异常"
                        logger.info("发送状态:false - 文件名: %s : result: %s.", i, result)
                    elif ret == -101:
                        result = "md5异常"
                        logger.info("发送状态:false - 文件名: %s : result: %s.", i, result)
                    elif ret == -5:
                        result = "服务器响应异常"
                        logger.info("发送状态:false - 文件名: %s : result: %s.", i, result)
                    elif ret == -4:
                        result = "md5加密异常"
                        logger.info("发送状态:false - 文件名: %s : result: %s.", i, result)
                    elif ret == -3:
                        result = "服务器异常"
                        logger.info("发送状态:false - 文件名: %s : result: %s.", i, result)
                    elif ret == -2:
                        result = "网络异常"
                        logger.info("发送状态:false - 文件名: %s : result: %s.", i, result)
                    elif ret == -1:
                        result = "information参数无法转化为json格式"
                        logger.info("发送状态:false - 文件名: %s : result: %s.", i, result)
                    # print("append: ", i)
                    new_installlist.append(i)             # 发送失败，加入新列表中
                elif ret == 0:
                    print("remove jsonfile: ", jsonpath)
                    os.remove(jsonpath)                # 删除本地json
                    logger.info("删除本地Json----- %s -----", i)
                    result = "发送信息成功"
                    logger.info("发送状态:false - 文件名: %s : result: %s.", i, result)
                logger.info("InstallInfo结束发送----- %s ----- ", jsonfile['install-info']['pkg-name'])
                print("InstallInfo结束发送----- %s ----- ", jsonfile['install-info']['pkg-name'])
            f.close()
        except Exception as e:
            print("open or remove: ", str(e))
    sendfail_install.set("SENDFAIL","jsonfile", " ".join(new_installlist))
    with open(INSTALL_SNEDFAIL_PATH,"w+") as f:
        sendfail_install.write(f)

def SendtoServer(jsondata):
    try:
        if "update-infos" in jsondata.keys():   # dbus发送第一组信息:update-infos
            if jsondata['update-infos']['sent'] == "false":
                jsondata['update-infos']['sent'] = "true"
                # print("jsonfile: ", jsondata, "     type: ", type(jsondata))
                enMB = cv.uniqueEnMd5Base64(jsondata)     # md5
                # dbus 发送
                applicationName="kylin-update-manager"
                messageType="update-infos"
                jsonfile = cv.ConvertJson(jsondata).replace(" ","")
                jsonfile = jsonfile.replace(" ","")
                # 调用dbus发送
                ret = sendToDbus(applicationName, messageType, jsonfile, enMB)
                if ret != 0: 
                    jsondata['update-infos']['sent'] = "false"
            # logger.info("发送状态:%s - Json名: %s ", jsondata['update-infos']['sent'], jsondata['update-infos']['pkg-name']+".json")
        elif "install-info" in jsondata.keys(): 
            # dbus发送第二组信息:install-info
            enMB = cv.uniqueEnMd5Base64(jsondata)     # md5
            applicationName="kylin-update-manager"
            messageType="install-info"
            jsonfile = cv.ConvertJson(jsondata)
            jsonfile = jsonfile.replace(" ","")
            # 调用dbus发送
            ret = sendToDbus(applicationName, messageType, jsonfile, enMB)
        else:
            ret = -10
            print("json err.")
    except Exception as e:
        print("SendtoServer: ", str(e))
    return ret 

def sendToDbus(applicationName, messageType, jsonfile, enMB):
    daqbus = dbus.SystemBus()
    daqobj = daqbus.get_object('com.kylin.daq', '/com/kylin/daq')
    daqinterface = dbus.Interface(daqobj, dbus_interface='com.kylin.daq.interface')
    retval = daqinterface.sendInfo(applicationName, messageType, jsonfile, enMB)
    # if "kylin-video" in str(jsonfile):
    #     return 0
    # print("ret = ", retval)
    return retval

if __name__ == "__main__":
    SendJson()